
        .MODEL  SMALL
        .STACK  512

;#########################################################################################################################

        .CONST

        .DATA

color   db 02
lado    dw 0
nivel   dw 200
inicio  dw 32h
coluna  dw 96h
linha   dw 10h
quedas  dw 180
cont    db 0h
frase1  db ' ','$'

        .DATA?

;#########################################################################################################################

        .CODE

myproc  PROC    FAR

;initialize the data segment

        mov     ax,@DATA
        mov     ds,ax

        mov     ax,4          ;modo graf 320x200 color mode
        int     10h           ;invoca a int 10h da BIOS	

        mov     ah,11         ;prepara configurao da palete de cores
        mov     bh,0          ;inicializa a cor de background
        mov     bl,1          ;background azul
        int     10h           ;invoca a interrupo 10h da BIOS

        mov     ah,11         ;prepara configurao da palete de cores
        mov     bh,1          ;prepara conf do foreground
        mov     bl,0          ;verde,vermelho e amarelo
        int     10h           ;invoca a intrrupo 10h da Bios

quad:   mov     quedas,180    ;falls = 180
        push    ax
        push    bx
        push    dx
        push    ds
        xor     ax,ax
        mov     ds,ax
        lds     ax,ds:[46Ch]
        mov     dx,ds
        mov     bx,301
        pop     ds
        div     bx
        mov     coluna,dx
        pop     dx
        pop     bx
        pop     ax

;desenhar o primeiro rectangulo

        push    ax
        push    bx
        push    dx
        push    cx

quad1:  cmp     quedas,0
        je      quad

        call    pixel
        mov     dx,98h        ;selecciona a linha 100
        mov     cx,inicio     ;selecciona a coluna 158
        call    proc1

here:   call    pixel
        push    dx
        mov     ah,6          ;apenas espera
        mov     dl,0FFh
        int     21h           ;por outra tecla
        pop     dx
 jz skip1

        cmp     al,6Eh        ;se for igual a tecla n vai apagar quadrado
        je      apaga

        cmp     al,6Dh        ;se for igual a tecla m vai apagar quadrado
        je      apaga

        cmp     al,31h        ;se for igual a tecla n vai apagar quadrado
        je      nivel1

nivel1: mov     nivel,20      ;se carrega na tecla 1 a bola anda a 200 milisegundos
        cmp     al,32h        ;se for igual a tecla n vai apagar quadrado
        je      nivel2

nivel2: mov     nivel,500     ;se carrega na tecla 2 a bola anda a 500 milisegundos
        cmp     al,0Dh        ;se for ENTER sai do programa
        je      fim

skip1:  push    dx
        mov     ah,6          ;apenas espera
        mov     dl,0FFh
        int     21h           ;por outra tecla
        pop     dx
 jz here

        cmp     al,0Dh        ;enquanto for diferente de ENTER no sai do programa
        jne     here

apaga:  mov     color,0
        push    ax
        sub     ah,ah
        mov     lado,ax
        pop     ax
        call    proc1
        mov     color,2
        cmp     lado,6Dh      ;se foi escolhida a tecla para a direita vai ser desenhado o quadrado  direita
        je      inicio2

        cmp     lado,6Eh      ;se foi escolhida a tecla para a esquerda vai ser desenhado o quadrado  esquerda
        je      inicio1

inicio2:
        cmp     inicio,12Ch
        jbe     adiciona

adiciona:
        add     inicio,10h    ;vai andar 10 casas para a direita
        jmp     quad1

inicio1:
        cmp     inicio,10h
        jge     subtrai

subtrai:
        sub     inicio,10h    ;vai andar 10 casas para a esquerda
        jmp     quad1

fim:    mov     ah,1          ;apenas espera
        int     21h           ;por outra tecla
        mov     ah,0          ;prepara para definir o modo grafico
        mov     al,2          ;repor modo texto.80.25
        int     10h           ;invoca a interrupo 10h da Bios
        pop     cx
        pop     dx
        pop     bx
        pop     ax
        mov     ax,4C00h
        int     21h

myproc  ENDP

;#########################################################################################################################

proc1   PROC    NEAR

        push    ax
        push    bx
        mov     ax,10
        call    msdelay
        mov     bl,0          ;
        mov     bh,0          ;
	
um:     mov     al,bl
        cmp     al,20         ;compara o valor que esta em AL  igual a 20
        jg      iniciofor2    ;salta se for igual a 20

        call    linha1
        inc     bl
        jmp     um

;linhas na vertical

iniciofor2:
        mov     bl,0          ;inicia for a zero

dois:   mov     al,bl         ;colocar o valor de BL em AL
        cmp     al,30         ;compara se o valor que est no AL  igual a 30
        jg      iniciofor3

        call    coluna1
        inc     bl
        jmp     dois

;linha horizontal

iniciofor3:
        mov     bl,0          ;coloca o 0 no BL

tres:
        mov     al,bl
        cmp     al,20
        jg      iniciofor4    ;salta para inicio4 se for menor 20

        call    linha2        ;seno chama o procedimento linha esquerda, que  para desenhar as linhas
        inc     bl            ;incrementa o BL
        jmp     tres          ;salta para 3

;++++++++++++++++++++++++linha vertical em comprimentos ao anterior++++++++++++++++++++++++++++++++++++++++

iniciofor4:
        mov     bl,0          ;inicia a zero

quatro:
        mov     al,bl
        cmp     al,30         ;nmero de vezes que faz
        jg      sair

        call    coluna2
        inc     bl
        jmp     quatro

sair:   pop     bx
        pop     ax
        ret

proc1   ENDP

;#########################################################################################################################
	
pixel   PROC    NEAR

        push    dx
        push    cx
        push    ax
        mov     dx,linha      ;determina a linha em que comea a cair
        mov     cx,quedas     ;determina o numero de vezes q vai cair

game:   push    cx
        mov     al,2          ;pixel cor vermelha
        mov     ah,12
        mov     cx,coluna
        int     10h
;        mov     ah,1
;        int     21h           ;espera por uma tecla
        push    ax
        mov     ax,nivel
        call    MsDelay
        pop     ax
        mov     al,0          ;pixel cor preto
        mov     ah,12
        mov     cx,coluna     ;considerando que temos 300 colunas
        int     10h
        inc     cont          ;incrementa o contador
        inc     dx
        mov     linha,dx      ;guarda a linha em que est
        mov     quedas,cx     ;guarda o numero de vezes que caiu
        pop     cx
        cmp     cont,9
        je      exit

        loop    game

exit:   mov     cont,0
        pop     ax
        pop     cx
        pop     dx
        ret

pixel   ENDP

;#########################################################################################################################

linha1  PROC    NEAR

        mov     al,color      ;cor dos pontos vermelho, configura
        mov     ah,12         ;conf int 10h para plot do pixel
        inc     dx            ;vai incrementar o nmero de vezes que for chamado dentro do FOR
        int     10h           ;invoca a int 10h
        ret

linha1  ENDP

;#########################################################################################################################

linha2  PROC    NEAR

        mov     al,color      ;cor dos pontos vermelho, configura
        mov     ah,12         ;conf int 10h para plot do pixel
        dec     dx            ;vai decrementar o nmero de vezes que for chamado dentro do FOR
        int     10h           ;invoca a int 10h
        ret

linha2  ENDP

;#########################################################################################################################

coluna2 PROC    NEAR

        mov     al,color      ;cor dos pontos vermelho, configura
        mov     ah,12         ;conf int 10h para plot do pixel
        inc     cx            ;vai incrementar o nmero de vezes que for chamado dentro do FOR
        int     10h           ;invoca a int 10h
        ret

coluna2 ENDP

;#########################################################################################################################

coluna1 PROC    NEAR

        mov     al,color      ;cor dos pontos vermelho, configura
        mov     ah,12         ;conf int 10h para plot do pixel
        dec     cx            ;vai decrementar o nmero de vezes que for chamado dentro do FOR
        int     10h           ;invoca a int 10h
        ret

coluna1 ENDP

;#########################################################################################################################

msdelay PROC    NEAR
;
; This proc delays for the specified number of milliseconds.
; It does this by counting memory refresh requests, which
; for AT-class systems are generated by system timer 1,
; normally programmed by the BIOS to generate an output once
; every 18/1193182 = 15.09 microseconds. Each request toggles
; bit 4 of I/O port 61h. We are counting full cycles of the
; bit, with two toggles per cycle, so each cycle takes 30.18
; microseconds and we count 34 cycles for each millisecond.
;
; Call with the number of milliseconds in AX.
;
; Preserves all registers other than AX.
;
; Note that the delay will be much shorter when running
; under the NT versions of Windows.
; -----------------------------------------------------------

        push    cx
        mov     cx,ax         ;load msLoop count

msLoop: push    cx            ;preserve msLoop counter
        mov     cx,34         ;load repeat count

wait1:  in      al,61h        ;read byte from port
        test    al,10h        ;test bit 4
        jz      wait1         ;jump if bit clear

wait2:  in      al,61h        ;read byte from port
        test    al,10h        ;test bit 4
        jnz     wait2         ;jump if bit not clear

        dec     cx            ;decrement repeat count
        jnz     wait1         ;jump if count not zero

        pop     cx            ;recover msLoop counter
        dec     cx            ;decrement msLoop count
        jnz     msLoop        ;jump if count not zero

        pop     cx
        ret

msdelay ENDP

;#########################################################################################################################

        END     myproc

